 namespace std
{
  typedef long unsigned int size_t;
  typedef decltype(nullptr) nullptr_t;
}
namespace std
{
  inline namespace __cxx11 __attribute__((__abi_tag__ )) { }
}
typedef unsigned char uint8_t;
typedef unsigned long int uintmax_t;
namespace std
{
  using ::uint8_t;
  struct __false_type { };
  template<typename _Tp>
    __addressof(_Tp& __r) noexcept
    {
    }
  template<typename _Tp, _Tp __v>
    struct integral_constant
    {
      static constexpr _Tp value = __v;
    };
  typedef integral_constant<bool, false> false_type;
  template<bool, typename, typename>
    struct conditional;
    struct __is_void_helper
    : public false_type { };
  template<typename _Tp>
    struct is_void
    : public false_type { };
  template<typename>
    struct is_function;
  template<typename _Tp>
    struct is_member_object_pointer
    : public integral_constant<bool, is_function<_Tp>::value> { };
  template<typename _Tp>
    struct is_member_function_pointer
    ;
  template<typename _Tp>
    struct is_arithmetic
    ;
  template<typename _Tp>
    struct is_empty
    ;
  template<typename _Tp,
    bool = is_arithmetic<_Tp>::value>
    struct add_rvalue_reference;
  template<typename _Tp>
    typename add_rvalue_reference<_Tp>::type declval() noexcept;
  template<typename, typename>
    struct is_same;
  template<typename _Tp, typename... _Args>
    struct is_constructible
    ;
  template<typename _Tp>
    struct remove_cv
    ;
  template<typename _Tp>
    struct remove_reference
    { typedef _Tp type; };
  template<typename _Tp>
    struct remove_reference<_Tp&>
    { typedef _Tp type; };
  template<bool, typename _Tp = void>
    struct enable_if
    ;
  template<typename _Iftrue, typename _Iffalse>
    struct conditional<false, _Iftrue, _Iffalse>
    { typedef _Iffalse type; };
  template<typename _Signature>
    class result_of;
  template<bool, bool, typename _Functor, typename... _ArgTypes>
    struct __result_of_impl
    ;
  template<typename _Functor, typename... _ArgTypes>
    struct result_of<_Functor(_ArgTypes...)>
    : public __result_of_impl<
        is_member_object_pointer<
          typename remove_reference<_Functor>::type
        >::value,
        is_member_function_pointer<
          typename remove_reference<_Functor>::type
        >::value,
     _Functor, _ArgTypes...
      >::type
    { };
  template<typename _Default, typename _AlwaysVoid,
    template<typename...> class _Op, typename... _Args>
    struct __detector
    ;
  template<typename _Default, template<typename...> class _Op,
    typename... _Args>
    using __detected_or = __detector<_Default, void, _Op, _Args...>;
  template<typename _Default, template<typename...> class _Op,
    typename... _Args>
    using __detected_or_t
      = typename __detected_or<_Default, _Op, _Args...>::type;
  template<template<typename...> class _Default,
    template<typename...> class _Op, typename... _Args>
    using __detected_or_t_ =
      __detected_or_t<_Default<_Args...>, _Op, _Args...>;
  template<typename _Tp>
    constexpr _Tp&&
    forward(typename std::remove_reference<_Tp>::type& __t) noexcept
    { return static_cast<_Tp&&>(__t); }
  template<typename _Tp>
    constexpr typename std::remove_reference<_Tp>::type&&
    move(_Tp&& __t) noexcept
    { return static_cast<typename std::remove_reference<_Tp>::type&&>(__t); }
  struct input_iterator_tag { };
  struct forward_iterator_tag : public input_iterator_tag { };
    struct iterator
    ;
  template<typename _Tp, typename _Up>
    struct __replace_first_arg
    ;
  template<typename _Tp, typename _Up>
    using __replace_first_arg_t = typename __replace_first_arg<_Tp, _Up>::type;
}
namespace std __attribute__ ((__visibility__ ))
{

  template<bool _IsMove, typename _II, typename _OI>
    __copy_move_a(_II __first, _II __last, _OI __result)
    {
    }
  template<typename _CharT>
    struct char_traits;
  template<bool _IsMove, typename _II, typename _OI>
    __copy_move_a2(_II __first, _II __last, _OI __result)
    {
    }
  template<typename _II1, typename _II2>
    __equal_aux(_II1 __first1, _II1 __last1, _II2 __first2)
    {
  }
}
inline void* operator new(std::size_t, void* __p) noexcept
{ return __p; }
namespace __gnu_cxx __attribute__ ((__visibility__ ))
{
  template<typename _Tp>
    class new_allocator
    {
    public:
      template<typename _Up, typename... _Args>
        construct(_Up* __p, _Args&&... __args)
 { new _Up(std::forward<_Args>(__args)...); }
    };
}
namespace std
{
  template<typename _Tp>
    using __allocator_base = __gnu_cxx::new_allocator<_Tp>;
  template<typename _Tp>
    class allocator: public __allocator_base<_Tp>
    {
    };
  struct __allocator_traits_base
  {
    template<typename _Alloc, typename _Up>
      using __rebind = typename _Alloc::template rebind::other;
  };
  template<typename _Alloc, typename _Up>
    using __alloc_rebind = __detected_or_t_<__replace_first_arg_t,
         __allocator_traits_base::__rebind,
         _Alloc, _Up>;
  template<typename _Alloc>
    struct allocator_traits : __allocator_traits_base
    {
    };
  template<typename _Tp>
    struct allocator_traits<allocator<_Tp>>
    {
      using allocator_type = allocator<_Tp>;
      using pointer = _Tp*;
      template<typename _Up>
 using rebind_alloc = allocator<_Up>;
      template<typename _Up, typename... _Args>
 static void
 construct(allocator_type& __a, _Up* __p, _Args&&... __args)
 { __a.construct(__p, std::forward<_Args>(__args)...); }
    };
}
namespace __gnu_cxx __attribute__ ((__visibility__ ))
{
template<typename _Alloc>
  struct __alloc_traits
  : std::allocator_traits<_Alloc>
  {
    typedef std::allocator_traits<_Alloc> _Base_type;
    template<typename _Tp>
      struct rebind
      { typedef typename _Base_type::template rebind_alloc<_Tp> other; };
  };
}
namespace std __attribute__ ((__visibility__ ))
{
  template<typename _InputIterator, typename _ForwardIterator>
    uninitialized_copy(_InputIterator __first, _InputIterator __last,
         _ForwardIterator __result)
    {
    }
  template<typename _Tp, typename _Alloc>
    struct _Vector_base
    {
      typedef typename __gnu_cxx::__alloc_traits<_Alloc>::template
        rebind<_Tp>::other _Tp_alloc_type;
      typedef typename __gnu_cxx::__alloc_traits<_Tp_alloc_type>::pointer
        pointer;
      struct _Vector_impl
      : public _Tp_alloc_type
      {
 pointer _M_finish;
      };
      _Vector_impl _M_impl;
    };
  template<typename _Tp, typename _Alloc = std::allocator<_Tp> >
    class vector : protected _Vector_base<_Tp, _Alloc>
    {
      typedef _Vector_base<_Tp, _Alloc> _Base;
      typedef typename _Base::_Tp_alloc_type _Tp_alloc_type;
      typedef __gnu_cxx::__alloc_traits<_Tp_alloc_type> _Alloc_traits;
    public:
      typedef _Tp value_type;
      push_back(value_type&& __x)
      { emplace_back(std::move(__x)); }
      template<typename... _Args>
        void
        emplace_back(_Args&&... __args);
      template<typename _InputIterator>
        void
        _M_range_insert(iterator __pos, _InputIterator __first,
   _InputIterator __last, std::input_iterator_tag);
      template<typename _ForwardIterator>
        void
        _M_range_insert(iterator __pos, _ForwardIterator __first,
   _ForwardIterator __last, std::forward_iterator_tag);
    };
  template<typename _Alloc>
    struct _Bvector_base
    ;
template<typename _Alloc>
  class vector<bool, _Alloc> : protected _Bvector_base<_Alloc>
  {
    template<typename _InputIterator>
      _M_initialize_range(_InputIterator __first, _InputIterator __last,
     std::input_iterator_tag)
      {
      }
    template<typename _ForwardIterator>
      void
      _M_insert_range(iterator __position, _ForwardIterator __first,
        _ForwardIterator __last, std::forward_iterator_tag);
  };
  template<typename _Tp, typename _Alloc>
    template<typename... _Args>
      void
      vector<_Tp, _Alloc>::
      emplace_back(_Args&&... __args)
   {
     _Alloc_traits::construct(this->_M_impl, this->_M_impl._M_finish,
         std::forward<_Args>(__args)...);
   }
  template<typename _Tp, typename _Alloc>
    template<typename _ForwardIterator>
      void
      vector<_Tp, _Alloc>::
      _M_range_insert(iterator __position, _ForwardIterator __first,
        _ForwardIterator __last, std::forward_iterator_tag)
      ;
  template<typename _Alloc>
    template<typename _ForwardIterator>
      void
      vector<bool, _Alloc>::
      _M_insert_range(iterator __position, _ForwardIterator __first,
        _ForwardIterator __last, std::forward_iterator_tag)
    ;
}
namespace padis {
namespace listener {
namespace tlv {
inline namespace _v1 {
namespace traits {
template<typename CodeType, std::size_t HeaderLength, std::size_t MinimumValueLength, std::size_t MaximumValueLength>
struct generic_tlv_config {
    typedef CodeType code_type;
};
}
template<typename TlvConfig>
class GenericTlv {
    virtual std::size_t getHeaderLength() const= 0;
    virtual std::size_t getMaximumValueLength() const= 0;
    virtual std::size_t getMinimumValueLength() const= 0;
    virtual std::size_t getValueLength() const=0;
    virtual typename TlvConfig::code_type getCode() const=0;
    virtual bool operator==(const GenericTlv &other) const= 0;
};
template<typename TlvConfig, typename TlvConfig::code_type Id, class ImplClass>
class GenericTlvBase : public virtual GenericTlv<TlvConfig> {
    virtual inline std::size_t getHeaderLength() const override;
    virtual inline std::size_t getMaximumValueLength() const override;
    virtual inline std::size_t getMinimumValueLength() const override;
    inline typename TlvConfig::code_type getCode() const override;
    inline bool operator==(const GenericTlv<TlvConfig> &other) const override;
    virtual bool operator==(const ImplClass &other) const= 0;
};
}
}
    }
  template<typename _Ret, typename _Tp, typename _Arg>
    mem_fun(_Ret )
    {
}
}
namespace std __attribute__ ((__visibility__ ))
{
namespace __cxx11 {
  template<typename _CharT, typename _Traits = char_traits<_CharT>,
           typename _Alloc = allocator<_CharT> >
    class basic_string;
  typedef basic_string<char> string;
}
}
namespace std __attribute__ ((__visibility__ ))
{
  template<typename _CharT, typename _Traits = char_traits<_CharT> >
    class ostreambuf_iterator;
__bswap_32 (unsigned int __bsx)
{
}
}
namespace std __attribute__ ((__visibility__ ))
{
namespace __cxx11 {
  template<typename _CharT>
    class collate;
}
}


namespace mpl_ {  }
namespace boost { namespace mpl { using namespace mpl_;
}}
namespace mpl_ {
template< int N >
struct int_
{
    static const int value = N;
};
}
namespace boost { namespace mpl { namespace aux {
template< typename F > struct template_arity;
}}}
namespace mpl_ {
template< bool C_ > struct bool_;
typedef bool_<true> true_;
typedef bool_<false> false_;
template< bool C_ > struct bool_
{
    static const bool value = C_;
    typedef bool_ type;
};
template< typename T, T N >
struct integral_c
;
template< bool C >
struct integral_c<bool, C>
{
    static const bool value = C;
};
}
namespace boost{
template <class T, T val>
struct integral_constant : public mpl::integral_c<T, val>
{
};
template< typename T > struct is_lvalue_reference : public boost::integral_constant<bool,false> { public: };
template< typename T > struct is_rvalue_reference : public boost::integral_constant<bool,false> { public: };
namespace type_traits {
template <bool b1, bool b2, bool b3 = false, bool b4 = false, bool b5 = false, bool b6 = false, bool b7 = false>
struct ice_or;
template <>
struct ice_or<false, false, false, false, false, false, false>
{
    static const bool value = false;
};
}
namespace detail {
template <typename T>
struct is_reference_impl
{
   static const bool value = boost::type_traits::ice_or< boost::is_lvalue_reference<T>::value, boost::is_rvalue_reference<T>::value >::value
                 ;
};
}
template< typename T > struct is_reference : public boost::integral_constant<bool,boost::detail::is_reference_impl<T>::value> { public: };

}
namespace mpl_ {
struct void_;
struct na
{
    typedef na type;
    enum { value = 0 };
};
}
namespace boost { namespace mpl {
template< typename T >
struct is_na
    : true_
{
};
template<
      typename T = na
    , typename Tag = void_
    , typename Arity = int_< aux::template_arity<T>::value >
    >
struct lambda;
template<
      bool C
    , typename T1
    , typename T2
    >
struct if_c
{
    typedef T1 type;
};
template<
      typename T1
    , typename T2
    >
struct if_c<false,T1,T2>
{
    typedef T2 type;
};
template<
      typename T1 = na
    , typename T2 = na
    , typename T3 = na
    >
struct if_
{
    typedef if_c<
          static_cast<bool>(T1::value)
        , T2
        , T3
        > almost_type_;
    typedef typename almost_type_::type type;
};
}}
namespace boost { namespace mpl { namespace aux {
template< typename T > struct nested_type_wknd
    : T::type
{
};
template< bool C_, typename T1, typename T2, typename T3, typename T4 >
struct or_impl
    : true_
{
};
template< typename T1, typename T2, typename T3, typename T4 >
struct or_impl< false,T1,T2,T3,T4 >
    : or_impl<
          boost::mpl::aux::nested_type_wknd<T1>::value
        , T2, T3, T4
        , false_
        >
{
};
template<>
struct or_impl<
          false
        , false_, false_, false_, false_
        >
    : false_
{
};
}
template<
      typename T1 = na
    , typename T2 = na
    , typename T3 = false_, typename T4 = false_, typename T5 = false_
    >
struct or_
    : aux::or_impl<
          boost::mpl::aux::nested_type_wknd<T1>::value
        , T2, T3, T4, T5
        >
{
};
}}
namespace mpl_ {
template< int N > struct arg;
}
namespace boost { namespace mpl {

template<
      typename T = na
    >
struct not_
{
};
}}
namespace boost { namespace mpl { namespace aux {
typedef char (&no_tag)[1];
typedef char (&yes_tag)[2];
}}}
namespace mpl_ {
template<> struct arg<1>
{
    template<
          typename U1 = na, typename U2 = na, typename U3 = na
        , typename U4 = na, typename U5 = na
        >
    struct apply
    {
        typedef U1 type;
    };
};
template<> struct arg<2>
{
    template<
          typename U1 = na, typename U2 = na, typename U3 = na
        , typename U4 = na, typename U5 = na
        >
    struct apply
    {
        typedef U2 type;
    };
};
}
namespace boost { namespace mpl { namespace aux {
template< typename T > struct type_wrapper
{
};
template< int N > struct arity_tag
{
    typedef char (&type)[N + 1];
};
template<
      int C1, int C2, int C3, int C4, int C5, int C6
    >
struct max_arity
{
    static const int value =  C6 > 0 ? C6 :  C5 > 0 ? C5 :  C4 > 0 ? C4 :  C3 > 0 ? C3 :  C2 > 0 ? C2 :  C1 > 0 ? C1 : -1      
         ;
};
arity_tag<0>::type arity_helper(...);
template<
      template< typename P1 > class F
    , typename T1
    >
typename arity_tag<1>::type
arity_helper(type_wrapper< F<T1> >, arity_tag<1>);
template< typename F, int N >
struct template_arity_impl
{
    static const int value = sizeof::boost::mpl::aux::arity_helper(type_wrapper<F>(), arity_tag<N>()) - 1
         ;
};
template< typename F >
struct template_arity
{
    static const int value =  max_arity< template_arity_impl< F,1 >::value, template_arity_impl< F,2 >::value, template_arity_impl< F,3 >::value, template_arity_impl< F,4 >::value, template_arity_impl< F,5 >::value, template_arity_impl< F,6 >::value >::value 
          ;
};
}}}
namespace boost {
namespace detail { namespace variant {
template <typename T>
class backup_holder
{
    T* backup_;
public:
    const T& get() const noexcept
    {
        return *backup_;
    }
};
template <typename T>
struct is_recursive_flag
    : mpl::false_
{
};
}}
namespace detail {
template <typename T = mpl::void_> struct make_reference_content;
template <typename T>
struct make_reference_content
{
    typedef T type;
};
template <>
struct make_reference_content< mpl::void_ >
{
    template <typename T>
    struct apply
        : make_reference_content<T>
    {
    };
};
}
template <typename T>
struct unwrap_recursive
{
    typedef T type;
};
}

namespace boost {
namespace move_detail {
template<class T>
struct remove_reference
{
   typedef T type;
};
}
         template <class T>
         inline typename boost::move_detail::remove_reference<T>::type && move(T&& t) noexcept
         { return static_cast<typename boost::move_detail::remove_reference<T>::type &&>(t); }

  template<typename _ForwardIterator1, typename _ForwardIterator2>
    is_permutation(_ForwardIterator1 __first1, _ForwardIterator1 __last1,
     _ForwardIterator2 __first2, _ForwardIterator2 __last2)
    {
    }
}
namespace __gnu_cxx __attribute__ ((__visibility__ ))
{
  enum _Lock_policy { _S_single, _S_mutex, _S_atomic };
  static const _Lock_policy __default_lock_policy ;
}

namespace boost { namespace detail { namespace variant {
using boost::move;
}}}
namespace boost { namespace mpl {
template<
      typename C = na
    , typename F1 = na
    , typename F2 = na
    >
struct eval_if
{
    typedef typename if_<C,F1,F2>::type f_;
    typedef typename f_::type type;
};
template<
      bool C
    , typename F1
    , typename F2
    >
struct eval_if_c
{
    typedef typename if_c<C,F1,F2>::type f_;
    typedef typename f_::type type;
};
}}
namespace boost { namespace mpl { namespace aux {
template< typename T, typename fallback_ = boost::mpl::bool_<true> > struct has_begin { struct gcc_3_2_wknd { template< typename U > static boost::mpl::aux::yes_tag test( boost::mpl::aux::type_wrapper<U> const volatile* , boost::mpl::aux::type_wrapper<typename U::begin>* = 0 ); static boost::mpl::aux::no_tag test(...); }; typedef boost::mpl::aux::type_wrapper<T> t_; static const bool value = sizeof(gcc_3_2_wknd::test) == sizeof(boost::mpl::aux::yes_tag); typedef boost::mpl::bool_<value> type; };
}
template< typename Tag >
struct begin_impl
;
template< typename Tag >
struct end_impl
;
}}
namespace boost { namespace mpl { namespace aux {
template< typename T, typename fallback_ = boost::mpl::bool_<false> > struct has_tag { struct gcc_3_2_wknd { template< typename U > static boost::mpl::aux::yes_tag test( boost::mpl::aux::type_wrapper<U> const volatile* , boost::mpl::aux::type_wrapper<typename U::tag>* = 0 ); static boost::mpl::aux::no_tag test(...); }; typedef boost::mpl::aux::type_wrapper<T> t_; static const bool value = sizeof(gcc_3_2_wknd::test(static_cast<t_*>(0))) == sizeof(boost::mpl::aux::yes_tag); typedef boost::mpl::bool_<value> type; };
template< bool has_tag_, bool has_begin_ >
struct sequence_tag_impl
;
template<> struct sequence_tag_impl<true,false> { template< typename Sequence > struct result2_ { typedef typename Sequence::tag type; }; };
}
template<
      typename Sequence = na
    >
struct sequence_tag
    : aux::sequence_tag_impl<
          boost::mpl::aux::has_tag<Sequence>::value
        , boost::mpl::aux::has_begin<Sequence>::value
        >::template result2_<Sequence>
{
};
template<
      typename Sequence = na
    >
struct begin
{
    typedef typename sequence_tag<Sequence>::type tag_;
    typedef typename begin_impl< tag_ >
        ::template apply< Sequence >::type type;
};
template<
      typename Sequence = na
    >
struct end
{
    typedef typename sequence_tag<Sequence>::type tag_;
    typedef typename end_impl< tag_ >
        ::template apply< Sequence >::type type;
};
}}
namespace mpl_ {
template< long N >
struct long_
{
    static const long value = N;
    typedef mpl_::long_< static_cast<long>(value + 1) > next;
};
}
namespace boost { namespace mpl { namespace aux {
template< typename T, typename fallback_ = boost::mpl::bool_<false> > struct has_size { struct gcc_3_2_wknd { template< typename U > static boost::mpl::aux::yes_tag test( boost::mpl::aux::type_wrapper<U> const volatile* , boost::mpl::aux::type_wrapper<typename U::size>* = 0 ); static boost::mpl::aux::no_tag test(...); }; typedef boost::mpl::aux::type_wrapper<T> t_; static const bool value = sizeof(gcc_3_2_wknd::test(static_cast<t_*>(0))) == sizeof(boost::mpl::aux::yes_tag); typedef boost::mpl::bool_<value> type; };
template< typename Sequence > struct O1_size_impl
    : Sequence::size
{
};
}
template< typename Tag >
struct O1_size_impl
{
    template< typename Sequence > struct apply
        : if_<
              aux::has_size<Sequence>
            , aux::O1_size_impl<Sequence>
            >::type
    {
    };
};
template<
      typename Sequence = na
    >
struct O1_size
    : O1_size_impl< typename sequence_tag<Sequence>::type >
        ::template apply< Sequence >
{
};
template<
      typename F, typename T1 = na, typename T2 = na, typename T3 = na
    , typename T4 = na, typename T5 = na
    >
struct bind;
template<
      typename F
    >
struct bind0;
template<
      typename F, typename T1, typename T2, typename T3, typename T4
    >
struct bind4;
}}
namespace mpl_ {
typedef arg<1> _1;
typedef arg<2> _2;
}
namespace boost { namespace mpl {
template<
      typename T = na
    >
struct next
{
    typedef typename T::next type;
};
template<
      typename T = na
    , int not_le_ = 0
    >
struct protect : T
{
};
template<
      typename F, typename T1
    >
struct apply_wrap1
    : F::template apply<T1>
{
};
template<
      typename F, typename T1, typename T2
    >
struct apply_wrap2
    : F::template apply< T1,T2 >
{
};
template<
      typename F, typename T1, typename T2, typename T3, typename T4
    , typename T5
    >
struct apply_wrap5
    : F::template apply< T1,T2,T3,T4,T5 >
{
};
namespace aux {
template<
      typename T, typename U1, typename U2, typename U3, typename U4
    , typename U5
    >
struct resolve_bind_arg
{
    typedef T type;
};
template<
      typename T
    , typename Arg
    >
struct replace_unnamed_arg
{
    typedef Arg next;
    typedef T type;
};
template<
      typename Arg
    >
struct replace_unnamed_arg< arg< -1 >, Arg >
;
template<
      int N, typename U1, typename U2, typename U3, typename U4, typename U5
    >
struct resolve_bind_arg< arg<N>, U1, U2, U3, U4, U5 >
{
    typedef typename apply_wrap5<mpl::arg<N>, U1, U2, U3, U4, U5>::type type;
};
template<
      typename F, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename U1, typename U2, typename U3, typename U4
    , typename U5
    >
struct resolve_bind_arg< bind< F,T1,T2,T3,T4,T5 >, U1, U2, U3, U4, U5 >
;
template<
      typename F, typename U1, typename U2, typename U3, typename U4
    , typename U5
    >
struct resolve_bind_arg
;
}
template<
      typename F, typename T1
    >
struct bind1
{
    template<
          typename U1 = na, typename U2 = na, typename U3 = na
        , typename U4 = na, typename U5 = na
        >
    struct apply
    {
        typedef aux::replace_unnamed_arg< F, mpl::arg<1> > r0;
        typedef typename r0::type a0;
        typedef typename r0::next n1;
        typedef typename aux::resolve_bind_arg< a0,U1,U2,U3,U4,U5 >::type f_;
        typedef aux::replace_unnamed_arg< T1,n1 > r1;
        typedef typename r1::type a1;
        typedef aux::resolve_bind_arg< a1,U1,U2,U3,U4,U5 > t1;
        typedef typename apply_wrap1<
              f_
            , typename t1::type
            >::type type;
    };
};
namespace aux {
template<
      typename F, typename T1, typename U1, typename U2, typename U3
    , typename U4, typename U5
    >
struct resolve_bind_arg<
      bind1< F,T1 >, U1, U2, U3, U4, U5
    >
{
    typedef bind1< F,T1 > f_;
    typedef typename apply_wrap5< f_,U1,U2,U3,U4,U5 >::type type;
};
}
template<
      typename F, typename T1, typename T2
    >
struct bind2
{
    template<
          typename U1 = na, typename U2 = na, typename U3 = na
        , typename U4 = na, typename U5 = na
        >
    struct apply
    {
        typedef aux::replace_unnamed_arg< F, mpl::arg<1> > r0;
        typedef typename r0::type a0;
        typedef typename r0::next n1;
        typedef typename aux::resolve_bind_arg< a0,U1,U2,U3,U4,U5 >::type f_;
        typedef aux::replace_unnamed_arg< T1,n1 > r1;
        typedef typename r1::type a1;
        typedef typename r1::next n2;
        typedef aux::resolve_bind_arg< a1,U1,U2,U3,U4,U5 > t1;
        typedef aux::replace_unnamed_arg< T2,n2 > r2;
        typedef typename r2::type a2;
        typedef aux::resolve_bind_arg< a2,U1,U2,U3,U4,U5 > t2;
        typedef typename apply_wrap2<
              f_
            , typename t1::type, typename t2::type
            >::type type;
    };
};
template<
      typename F, typename T1, typename T2, typename T3, typename T4
    >
struct bind5
;
}}
namespace boost { namespace mpl { namespace aux {
template< typename T, typename fallback_ = boost::mpl::bool_<true> > struct has_type { struct gcc_3_2_wknd { template< typename U > static boost::mpl::aux::yes_tag test( boost::mpl::aux::type_wrapper<U> const volatile* , boost::mpl::aux::type_wrapper<typename U::type>* = 0 ); static boost::mpl::aux::no_tag test(...); }; typedef boost::mpl::aux::type_wrapper<T> t_; static const bool value = sizeof(gcc_3_2_wknd::test) == sizeof(boost::mpl::aux::yes_tag); typedef boost::mpl::bool_<value> type; };
}}}
namespace boost { namespace mpl {
template< typename T, bool has_type_ >
struct quote_impl
{
    typedef typename T::type type;
};
template<
      template< typename P1 > class F
    , typename Tag = void_
    >
struct quote1
{
    template< typename U1 > struct apply
        : quote_impl<
              F<U1>
            , aux::has_type< F<U1> >::value
            >
    {
    };
};
namespace aux {
template<
      bool C1 = false, bool C2 = false, bool C3 = false, bool C4 = false
    >
struct lambda_or
    : true_
{
};
}
template<
      typename T
    , typename Tag
    , typename Arity
    >
struct lambda
{
    typedef T type;
};
template<
      typename T
    >
struct is_lambda_expression
;
template< int N, typename Tag >
struct lambda< arg<N>,Tag, int_< -1 > >
{
    typedef mpl::arg<N> result_;
    typedef mpl::protect<result_> type;
};
template<
      typename F
    , typename Tag
    >
struct lambda<
          bind0<F>
        , Tag
        >
;
namespace aux {
template<
      typename IsLE, typename Tag
    , template< typename P1 > class F
    , typename L1
    >
struct le_result1
;
template<
      typename Tag
    , template< typename P1 > class F
    , typename L1
    >
struct le_result1< true_,Tag,F,L1 >
{
    typedef bind1<
          quote1< F,Tag >
        , typename L1::result_
        > result_;
    typedef mpl::protect<result_> type;
};
}
template<
      template< typename P1 > class F
    , typename T1
    , typename Tag
    >
struct lambda<
          F<T1>
        , Tag
        >
{
    typedef lambda< T1,Tag > l1;
    typedef typename aux::lambda_or<
        >::type is_le;
    typedef aux::le_result1<
          is_le, Tag, F, l1
        > le_result_;
    typedef typename le_result_::type type;
};
template<
      template< typename P1, typename P2 > class F
    , typename T1, typename T2
    , typename Tag
    >
struct lambda<
          F< T1,T2 >
        , Tag
        >
;
template<
      typename F, typename T1, typename T2
    , typename Tag
    >
struct lambda<
          bind2< F,T1,T2 >
        , Tag
        , int_<3>
        >
;
template<
      template< typename P1, typename P2, typename P3 > class F
    , typename T1, typename T2, typename T3
    , typename Tag
    >
struct lambda<
          F< T1,T2,T3 >
        , Tag
        , int_<3>
        >
;

template<
      template< typename P1, typename P2, typename P3, typename P4 > class F
    , typename T1, typename T2, typename T3, typename T4
    , typename Tag
    >
struct lambda<
          F< T1,T2,T3,T4 >
        , Tag
        >
;
template<
      typename F, typename T1, typename T2, typename T3, typename T4
    , typename Tag
    >
struct lambda<
          bind4< F,T1,T2,T3,T4 >
        , Tag
        >
;

template<
      template<
          typename P1, typename P2, typename P3, typename P4
        , typename P5
        >
      class F
    , typename T1, typename T2, typename T3, typename T4, typename T5
    , typename Tag
    >
struct lambda<
          F< T1,T2,T3,T4,T5 >
        , Tag
        >
;
template<
      typename F, typename T1 = na, typename T2 = na, typename T3 = na
    , typename T4 = na, typename T5 = na
    >
struct apply;
template<
      typename F
    >
struct apply< F,na,na,na,na,na >
;
template<
      typename F, typename T1, typename T2
    >
struct apply2
    : apply_wrap2<
          typename lambda<F>::type
        , T1, T2
        >
{
};
template<
      typename F, typename T1, typename T2, typename T3, typename T4
    , typename T5
    >
struct apply5
    : apply_wrap5<
          typename lambda<F>::type
        , T1, T2, T3, T4, T5
        >
{
};
}}
namespace boost { namespace mpl { namespace aux {
template<
      int N
    , typename First
    , typename Last
    , typename State
    , typename ForwardOp
    >
struct iter_fold_impl;
template<
      typename First
    , typename Last
    , typename State
    , typename ForwardOp
    >
struct iter_fold_impl< 2,First,Last,State,ForwardOp >
{
    typedef First iter0;
    typedef State state0;
    typedef typename apply2< ForwardOp,state0,iter0 >::type state1;
    typedef typename mpl::next<iter0>::type iter1;
    typedef typename apply2< ForwardOp,state1,iter1 >::type state2;
    typedef state2 state;
};
template<
      typename First
    , typename Last
    , typename State
    , typename ForwardOp
    >
struct iter_fold_impl< 1,First,Last,State,ForwardOp >
;
template<
      typename Last
    , typename State
    , typename ForwardOp
    >
struct iter_fold_impl< 1,Last,Last,State,ForwardOp >
;
}}}
namespace boost { namespace mpl {
template<
      typename Sequence = na
    , typename State = na
    , typename ForwardOp = na
    >
struct iter_fold
{
    typedef typename aux::iter_fold_impl<
          boost::mpl::O1_size<Sequence>::value
        , typename begin<Sequence>::type
        , typename end<Sequence>::type
        , State
        , typename lambda<ForwardOp>::type
        >::state type;
};
template<
      typename Iterator = na
    >
struct deref
{
    typedef typename Iterator::type type;
};
template<
      typename T1 = na
    , typename T2 = na
    >
struct pair
{
    typedef T1 first;
};
}}
namespace boost {
namespace detail { namespace variant {
struct make_initializer_node
{
    template <typename BaseIndexPair, typename Iterator>
    struct apply
    {
        class initializer_node
        {
            typedef typename mpl::deref<Iterator>::type
                recursive_enabled_T;
            typedef typename unwrap_recursive<recursive_enabled_T>::type
                public_T;
            typedef boost::is_reference<public_T>
                is_reference_content_t;
            typedef typename boost::mpl::if_<is_reference_content_t, public_T, const public_T& >::type
                param_T;
        public:
            static int initialize(void* dest, param_T operand)
            {
                typedef typename boost::detail::make_reference_content<
                      recursive_enabled_T
                    >::type internal_T;
                new(dest) internal_T;
            }
        };
        typedef mpl::pair<
              initializer_node
            > type;
    };
};
class initializer_root
;
}}
}
namespace boost { namespace mpl {
template< typename Tag > struct push_front_impl;
}}
namespace boost { namespace mpl { namespace aux {
struct list_tag;
}}}
namespace boost { namespace mpl {
template<
      typename Size
    , typename T
    , typename Next
    >
struct l_item
{
    typedef aux::list_tag tag;
    typedef l_item type;
    typedef Size size;
    typedef T item;
    typedef Next next;
};
struct l_end
{
    typedef aux::list_tag tag;
    typedef l_end type;
    typedef long_<0> size;
};
template<>
struct push_front_impl< aux::list_tag >
{
    template< typename List, typename T > struct apply
    {
        typedef l_item<
              typename next<typename List::size>::type
            , T
            , typename List::type
            > type;
    };
};
template< typename Tag > struct has_push_back_impl;
template<>
struct has_push_back_impl< aux::list_tag >
{
    template< typename Seq > struct apply
        : false_
    {
    };
};
template< typename Tag > struct clear_impl;
template<>
struct clear_impl< aux::list_tag >
{
    template< typename List > struct apply
    {
        typedef l_end type;
    };
};
template< typename Node >
struct l_iter
{
    typedef typename Node::item type;
};
template< typename Node >
struct next< l_iter<Node> >
{
    typedef l_iter< typename Node::next > type;
};
template<>
struct begin_impl< aux::list_tag >
{
    template< typename List > struct apply
    {
        typedef l_iter<typename List::type> type;
    };
};
template<>
struct end_impl< aux::list_tag >
{
    template< typename > struct apply
    {
        typedef l_iter<l_end> type;
    };
};
template<
      typename T0
    >
struct list1
    : l_item<
          long_<1>
        , T0
        , l_end
        >
{
};
template<
      typename T0, typename T1
    >
struct list2
    : l_item<
          long_<2>
        , T0
        , list1<T1>
        >
{
};
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38
    >
struct list39
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    >
struct list40
    : l_item<
          long_<40>
        , T0
        , list39< T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18,T19,T20,T21,T22,T23,T24,T25,T26,T27,T28,T29,T30,T31,T32,T33,T34,T35,T36,T37,T38,T39 >
        >
{
};
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41
    >
struct list42
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42
    >
struct list43
    : l_item<
          long_<43>
        , T0
        , list42< T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18,T19,T20,T21,T22,T23,T24,T25,T26,T27,T28,T29,T30,T31,T32,T33,T34,T35,T36,T37,T38,T39,T40,T41,T42 >
        >
{
};
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43
    >
struct list44
    : l_item<
          long_<44>
        , T0
        , list43< T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18,T19,T20,T21,T22,T23,T24,T25,T26,T27,T28,T29,T30,T31,T32,T33,T34,T35,T36,T37,T38,T39,T40,T41,T42,T43 >
        >
{
};
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    >
struct list55
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55
    >
struct list56
    : l_item<
          long_<56>
        , T0
        , list55< T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18,T19,T20,T21,T22,T23,T24,T25,T26,T27,T28,T29,T30,T31,T32,T33,T34,T35,T36,T37,T38,T39,T40,T41,T42,T43,T44,T45,T46,T47,T48,T49,T50,T51,T52,T53,T54,T55 >
        >
{
};
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    >
struct list75
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75
    >
struct list76
    : l_item<
          long_<76>
        , T0
        , list75< T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18,T19,T20,T21,T22,T23,T24,T25,T26,T27,T28,T29,T30,T31,T32,T33,T34,T35,T36,T37,T38,T39,T40,T41,T42,T43,T44,T45,T46,T47,T48,T49,T50,T51,T52,T53,T54,T55,T56,T57,T58,T59,T60,T61,T62,T63,T64,T65,T66,T67,T68,T69,T70,T71,T72,T73,T74,T75 >
        >
{
};
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    , typename T90, typename T91
    >
struct list92
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    , typename T90, typename T91, typename T92
    >
struct list93
    : l_item<
          long_<93>
        , T0
        , list92< T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18,T19,T20,T21,T22,T23,T24,T25,T26,T27,T28,T29,T30,T31,T32,T33,T34,T35,T36,T37,T38,T39,T40,T41,T42,T43,T44,T45,T46,T47,T48,T49,T50,T51,T52,T53,T54,T55,T56,T57,T58,T59,T60,T61,T62,T63,T64,T65,T66,T67,T68,T69,T70,T71,T72,T73,T74,T75,T76,T77,T78,T79,T80,T81,T82,T83,T84,T85,T86,T87,T88,T89,T90,T91,T92 >
        >
{
};
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    , typename T90, typename T91, typename T92, typename T93
    >
struct list94
    : l_item<
          long_<94>
        , T0
        , list93< T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18,T19,T20,T21,T22,T23,T24,T25,T26,T27,T28,T29,T30,T31,T32,T33,T34,T35,T36,T37,T38,T39,T40,T41,T42,T43,T44,T45,T46,T47,T48,T49,T50,T51,T52,T53,T54,T55,T56,T57,T58,T59,T60,T61,T62,T63,T64,T65,T66,T67,T68,T69,T70,T71,T72,T73,T74,T75,T76,T77,T78,T79,T80,T81,T82,T83,T84,T85,T86,T87,T88,T89,T90,T91,T92,T93 >
        >
{
};
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    , typename T90, typename T91, typename T92, typename T93, typename T94
    , typename T95, typename T96, typename T97, typename T98
    >
struct list99
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    , typename T90, typename T91, typename T92, typename T93, typename T94
    , typename T95, typename T96, typename T97, typename T98, typename T99
    >
struct list100
    : l_item<
          long_<100>
        , T0
        , list99< T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18,T19,T20,T21,T22,T23,T24,T25,T26,T27,T28,T29,T30,T31,T32,T33,T34,T35,T36,T37,T38,T39,T40,T41,T42,T43,T44,T45,T46,T47,T48,T49,T50,T51,T52,T53,T54,T55,T56,T57,T58,T59,T60,T61,T62,T63,T64,T65,T66,T67,T68,T69,T70,T71,T72,T73,T74,T75,T76,T77,T78,T79,T80,T81,T82,T83,T84,T85,T86,T87,T88,T89,T90,T91,T92,T93,T94,T95,T96,T97,T98,T99 >
        >
{
};
template<
      typename T0 = na, typename T1 = na, typename T2 = na, typename T3 = na
    , typename T4 = na, typename T5 = na, typename T6 = na, typename T7 = na
    , typename T8 = na, typename T9 = na, typename T10 = na, typename T11 = na
    , typename T12 = na, typename T13 = na, typename T14 = na
    , typename T15 = na, typename T16 = na, typename T17 = na
    , typename T18 = na, typename T19 = na, typename T20 = na
    , typename T21 = na, typename T22 = na, typename T23 = na
    , typename T24 = na, typename T25 = na, typename T26 = na
    , typename T27 = na, typename T28 = na, typename T29 = na
    , typename T30 = na, typename T31 = na, typename T32 = na
    , typename T33 = na, typename T34 = na, typename T35 = na
    , typename T36 = na, typename T37 = na, typename T38 = na
    , typename T39 = na, typename T40 = na, typename T41 = na
    , typename T42 = na, typename T43 = na, typename T44 = na
    , typename T45 = na, typename T46 = na, typename T47 = na
    , typename T48 = na, typename T49 = na, typename T50 = na
    , typename T51 = na, typename T52 = na, typename T53 = na
    , typename T54 = na, typename T55 = na, typename T56 = na
    , typename T57 = na, typename T58 = na, typename T59 = na
    , typename T60 = na, typename T61 = na, typename T62 = na
    , typename T63 = na, typename T64 = na, typename T65 = na
    , typename T66 = na, typename T67 = na, typename T68 = na
    , typename T69 = na, typename T70 = na, typename T71 = na
    , typename T72 = na, typename T73 = na, typename T74 = na
    , typename T75 = na, typename T76 = na, typename T77 = na
    , typename T78 = na, typename T79 = na, typename T80 = na
    , typename T81 = na, typename T82 = na, typename T83 = na
    , typename T84 = na, typename T85 = na, typename T86 = na
    , typename T87 = na, typename T88 = na, typename T89 = na
    , typename T90 = na, typename T91 = na, typename T92 = na
    , typename T93 = na, typename T94 = na, typename T95 = na
    , typename T96 = na, typename T97 = na, typename T98 = na
    , typename T99 = na
    >
struct list;
template<
      typename T0
    >
struct list<
          T0, na, na, na, na, na, na, na, na, na, na, na, na, na, na, na, na
        >
;
template<
      typename T0, typename T1
    >
struct list<
          T0, T1, na, na, na, na, na, na, na, na, na, na, na, na, na, na, na
        >
    : list2< T0,T1 >
{
};
template<
      typename T0, typename T1, typename T2, typename T3
    >
struct list<
          T0, T1, T2, T3, na, na, na, na, na, na, na, na, na, na, na, na, na
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, na, na, na, na, na, na, na, na, na, na, na, na, na, na
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, na, na, na, na, na, na, na, na, na
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40, T41, T42
        , T43, T44, T45, T46, T47, T48, T49, T50, T51, T52
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40, T41, T42
        , T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53, T54, T55, T56
        , T57, T58, T59, T60, T61, T62, T63, T64, T65, T66, T67, T68, T69, T70
        , T71, T72, T73
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40, T41, T42
        , T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53, T54, T55, T56
        , T57, T58, T59, T60, T61, T62, T63, T64, T65, T66, T67, T68, T69, T70
        , T71, T72, T73, T74, T75, T76, T77, T78, T79, T80, T81, T82, T83, T84
        , T85, T86, T87
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40, T41, T42
        , T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53, T54, T55, T56
        , T57, T58, T59, T60, T61, T62, T63, T64, T65, T66, T67, T68, T69, T70
        , T71, T72, T73, T74, T75, T76, T77, T78, T79, T80, T81, T82, T83, T84
        , T85, T86, T87, T88
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40, T41, T42
        , T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53, T54, T55, T56
        , T57, T58, T59, T60, T61, T62, T63, T64, T65, T66, T67, T68, T69, T70
        , T71, T72, T73, T74, T75, T76, T77, T78, T79, T80, T81, T82, T83, T84
        , T85, T86, T87, T88, T89, na, na, na, na, na, na, na, na, na, na
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    , typename T90, typename T91, typename T92, typename T93
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40, T41, T42
        , T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53, T54, T55, T56
        , T57, T58, T59, T60, T61, T62, T63, T64, T65, T66, T67, T68, T69, T70
        , T71, T72, T73, T74, T75, T76, T77, T78, T79, T80, T81, T82, T83, T84
        , T85, T86, T87, T88, T89, T90, T91, T92, T93
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    , typename T90, typename T91, typename T92, typename T93, typename T94
    >
struct list<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40, T41, T42
        , T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53, T54, T55, T56
        , T57, T58, T59, T60, T61, T62, T63, T64, T65, T66, T67, T68, T69, T70
        , T71, T72, T73, T74, T75, T76, T77, T78, T79, T80, T81, T82, T83, T84
        , T85, T86, T87, T88, T89, T90, T91, T92, T93, T94
        >
;
template<
      typename T0, typename T1, typename T2, typename T3, typename T4
    , typename T5, typename T6, typename T7, typename T8, typename T9
    , typename T10, typename T11, typename T12, typename T13, typename T14
    , typename T15, typename T16, typename T17, typename T18, typename T19
    , typename T20, typename T21, typename T22, typename T23, typename T24
    , typename T25, typename T26, typename T27, typename T28, typename T29
    , typename T30, typename T31, typename T32, typename T33, typename T34
    , typename T35, typename T36, typename T37, typename T38, typename T39
    , typename T40, typename T41, typename T42, typename T43, typename T44
    , typename T45, typename T46, typename T47, typename T48, typename T49
    , typename T50, typename T51, typename T52, typename T53, typename T54
    , typename T55, typename T56, typename T57, typename T58, typename T59
    , typename T60, typename T61, typename T62, typename T63, typename T64
    , typename T65, typename T66, typename T67, typename T68, typename T69
    , typename T70, typename T71, typename T72, typename T73, typename T74
    , typename T75, typename T76, typename T77, typename T78, typename T79
    , typename T80, typename T81, typename T82, typename T83, typename T84
    , typename T85, typename T86, typename T87, typename T88, typename T89
    , typename T90, typename T91, typename T92, typename T93, typename T94
    , typename T95, typename T96, typename T97, typename T98, typename T99
    >
struct list
    : list100<
          T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14
        , T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28
        , T29, T30, T31, T32, T33, T34, T35, T36, T37, T38, T39, T40, T41, T42
        , T43, T44, T45, T46, T47, T48, T49, T50, T51, T52, T53, T54, T55, T56
        , T57, T58, T59, T60, T61, T62, T63, T64, T65, T66, T67, T68, T69, T70
        , T71, T72, T73, T74, T75, T76, T77, T78, T79, T80, T81, T82, T83, T84
        , T85, T86, T87, T88, T89, T90, T91, T92, T93, T94, T95, T96, T97, T98
        , T99
        >
{
};
}}
namespace boost {
namespace detail { namespace variant {
template < typename... T >
struct make_variant_list
{
    typedef typename mpl::list< T... >::type type;
};
template <typename Types>
struct is_over_sequence
    : mpl::false_
{
};
template <typename T>
inline T& cast_storage(void* storage)
{
    return *static_cast<T*>(storage);
}
}}
}
namespace boost { namespace mpl {
template<
      typename T = na
    >
struct identity
{
    typedef T type;
};
}}
namespace boost {
namespace type_traits_detail {
}
  template <bool B, class T = void>
  struct enable_if_c ;
  template <class Cond, class T = void>
  struct enable_if : public enable_if_c<Cond::value, T> {};
namespace detail{
template <class T>
struct is_nothrow_move_constructible_imp;
}
template< typename T > struct is_nothrow_move_constructible : public ::boost::integral_constant<bool,::boost::detail::is_nothrow_move_constructible_imp<T>::value> { public: };
namespace detail { namespace variant {
template <typename Iter, typename LastIter>
struct visitation_impl_step
{
    typedef typename mpl::deref<Iter>::type type;
    typedef visitation_impl_step next;
};
template <typename LastIter>
struct visitation_impl_step< LastIter,LastIter >
{
};
visitation_impl_invoke_impl(
    )
{
}
template <typename Visitor, typename VoidPtrCV, typename T>
    typename Visitor::result_type
visitation_impl_invoke_impl(
      int internal_which, Visitor& visitor, VoidPtrCV storage, T*
    , mpl::false_
    )
    {
        return visitor.internal_visit(
              cast_storage< backup_holder<T> >(storage), 1L
            );
    }
template <typename Visitor, typename VoidPtrCV, typename T, typename NoBackupFlag>
    typename Visitor::result_type
visitation_impl_invoke(
      int internal_which, Visitor& visitor, VoidPtrCV storage, T* t
    , NoBackupFlag
    , int
    )
{
    typedef typename mpl::or_<
        >::type never_uses_backup;
    return visitation_impl_invoke_impl(
          internal_which, visitor, storage, t
        , never_uses_backup()
        );
}
template <
      typename Which, typename step0
    , typename Visitor, typename VoidPtrCV
    , typename NoBackupFlag
    >
    typename Visitor::result_type
visitation_impl(
      const int internal_which, const int logical_which
    , Visitor& visitor, VoidPtrCV storage
    , mpl::false_
    , NoBackupFlag no_backup_flag
    , Which* = 0, step0* = 0
    )
{
    typedef typename step0::type T0; typedef typename step0::next step1; typedef typename step1::type T1; typedef typename step1::next step2; typedef typename step2::type T2; typedef typename step2::next step3; typedef typename step3::type T3; typedef typename step3::next step4; typedef typename step4::type T4; typedef typename step4::next step5; typedef typename step5::type T5; typedef typename step5::next step6; typedef typename step6::type T6; typedef typename step6::next step7; typedef typename step7::type T7; typedef typename step7::next step8; typedef typename step8::type T8; typedef typename step8::next step9; typedef typename step9::type T9; typedef typename step9::next step10; typedef typename step10::type T10; typedef typename step10::next step11; typedef typename step11::type T11; typedef typename step11::next step12; typedef typename step12::type T12; typedef typename step12::next step13; typedef typename step13::type T13; typedef typename step13::next step14; typedef typename step14::type T14; typedef typename step14::next step15; typedef typename step15::type T15; typedef typename step15::next step16; typedef typename step16::type T16; typedef typename step16::next step17; typedef typename step17::type T17; typedef typename step17::next step18; typedef typename step18::type T18; typedef typename step18::next step19; typedef typename step19::type T19; typedef typename step19::next step20; typedef typename step20::type T20; typedef typename step20::next step21; typedef typename step21::type T21; typedef typename step21::next step22; typedef typename step22::type T22; typedef typename step22::next step23; typedef typename step23::type T23; typedef typename step23::next step24; typedef typename step24::type T24; typedef typename step24::next step25; typedef typename step25::type T25; typedef typename step25::next step26; typedef typename step26::type T26; typedef typename step26::next step27; typedef typename step27::type T27; typedef typename step27::next step28; typedef typename step28::type T28; typedef typename step28::next step29; typedef typename step29::type T29; typedef typename step29::next step30; typedef typename step30::type T30; typedef typename step30::next step31; typedef typename step31::type T31; typedef typename step31::next step32; typedef typename step32::type T32; typedef typename step32::next step33; typedef typename step33::type T33; typedef typename step33::next step34; typedef typename step34::type T34; typedef typename step34::next step35; typedef typename step35::type T35; typedef typename step35::next step36; typedef typename step36::type T36; typedef typename step36::next step37; typedef typename step37::type T37; typedef typename step37::next step38; typedef typename step38::type T38; typedef typename step38::next step39; typedef typename step39::type T39; typedef typename step39::next step40; typedef typename step40::type T40; typedef typename step40::next step41; typedef typename step41::type T41; typedef typename step41::next step42; typedef typename step42::type T42; typedef typename step42::next step43; typedef typename step43::type T43; typedef typename step43::next step44; typedef typename step44::type T44; typedef typename step44::next step45; typedef typename step45::type T45; typedef typename step45::next step46; typedef typename step46::type T46; typedef typename step46::next step47; typedef typename step47::type T47; typedef typename step47::next step48; typedef typename step48::type T48; typedef typename step48::next step49; typedef typename step49::type T49; typedef typename step49::next step50; typedef typename step50::type T50; typedef typename step50::next step51; typedef typename step51::type T51; typedef typename step51::next step52; typedef typename step52::type T52; typedef typename step52::next step53; typedef typename step53::type T53; typedef typename step53::next step54; typedef typename step54::type T54; typedef typename step54::next step55; typedef typename step55::type T55; typedef typename step55::next step56; typedef typename step56::type T56; typedef typename step56::next step57; typedef typename step57::type T57; typedef typename step57::next step58; typedef typename step58::type T58; typedef typename step58::next step59; typedef typename step59::type T59; typedef typename step59::next step60; typedef typename step60::type T60; typedef typename step60::next step61; typedef typename step61::type T61; typedef typename step61::next step62; typedef typename step62::type T62; typedef typename step62::next step63; typedef typename step63::type T63; typedef typename step63::next step64; typedef typename step64::type T64; typedef typename step64::next step65; typedef typename step65::type T65; typedef typename step65::next step66; typedef typename step66::type T66; typedef typename step66::next step67; typedef typename step67::type T67; typedef typename step67::next step68; typedef typename step68::type T68; typedef typename step68::next step69; typedef typename step69::type T69; typedef typename step69::next step70; typedef typename step70::type T70; typedef typename step70::next step71; typedef typename step71::type T71; typedef typename step71::next step72; typedef typename step72::type T72; typedef typename step72::next step73; typedef typename step73::type T73; typedef typename step73::next step74; typedef typename step74::type T74; typedef typename step74::next step75; typedef typename step75::type T75; typedef typename step75::next step76; typedef typename step76::type T76; typedef typename step76::next step77; typedef typename step77::type T77; typedef typename step77::next step78; typedef typename step78::type T78; typedef typename step78::next step79; typedef typename step79::type T79; typedef typename step79::next step80; typedef typename step80::type T80; typedef typename step80::next step81; typedef typename step81::type T81; typedef typename step81::next step82; typedef typename step82::type T82; typedef typename step82::next step83; typedef typename step83::type T83; typedef typename step83::next step84; typedef typename step84::type T84; typedef typename step84::next step85; typedef typename step85::type T85; typedef typename step85::next step86; typedef typename step86::type T86; typedef typename step86::next step87; typedef typename step87::type T87; typedef typename step87::next step88; typedef typename step88::type T88; typedef typename step88::next step89; typedef typename step89::type T89; typedef typename step89::next step90; typedef typename step90::type T90; typedef typename step90::next step91; typedef typename step91::type T91; typedef typename step91::next step92; typedef typename step92::type T92; typedef typename step92::next step93; typedef typename step93::type T93; typedef typename step93::next step94; typedef typename step94::type T94; typedef typename step94::next step95; typedef typename step95::type T95; typedef typename step95::next step96; typedef typename step96::type T96; typedef typename step96::next step97; typedef typename step97::type T97; typedef typename step97::next step98; typedef typename step98::type T98; typedef typename step98::next step99; typedef typename step99::type T99; typedef typename step99::next step100;
    switch (logical_which)
    {
    case Which::value + 0: return visitation_impl_invoke( internal_which, visitor, storage , static_cast<T0*>(0) , no_backup_flag, 1L ); case Which::value + 1: return ; case Which::value + 2: return ; case Which::value + 3: return ; case Which::value + 4: return ; case Which::value + 5: return ; case Which::value + 6: return ; case Which::value + 7: return ; case Which::value + 8: return ; case Which::value + 9: return ; case Which::value + 10: return ; case Which::value + 11: return ; case Which::value + 12: return ; case Which::value + 13: return ; case Which::value + 14: return ; case Which::value + 15: return ; case Which::value + 16: return ; case Which::value + 17: return ; case Which::value + 18: return ; case Which::value + 19: return ; case Which::value + 20: return ; case Which::value + 21: return ; case Which::value + 22: return ; case Which::value + 23: return ; case Which::value + 24: return ; case Which::value + 25: return ; case Which::value + 26: return ; case Which::value + 27: return ; case Which::value + 28: return ; case Which::value + 29: return ; case Which::value + 30: return ; case Which::value + 31: return ; case Which::value + 32: return ; case Which::value + 33: return ; case Which::value + 34: return ; case Which::value + 35: return ; case Which::value + 36: return ; case Which::value + 37: return ; case Which::value + 38: return ; case Which::value + 39: return ; case Which::value + 40: return ; case Which::value + 41: return ; case Which::value + 42: return ; case Which::value + 43: return ; case Which::value + 44: return ; case Which::value + 45: return ; case Which::value + 46: return ; case Which::value + 47: return ; case Which::value + 48: return ; case Which::value + 49: return ; case Which::value + 50: return ; case Which::value + 51: return ; case Which::value + 52: return ; case Which::value + 53: return ; case Which::value + 54: return ; case Which::value + 55: return ; case Which::value + 56: return ; case Which::value + 57: return ; case Which::value + 58: return ; case Which::value + 59: return ; case Which::value + 60: return ; case Which::value + 61: return ; case Which::value + 62: return ; case Which::value + 63: return ; case Which::value + 64: return ; case Which::value + 65: return ; case Which::value + 66: return ; case Which::value + 67: return ; case Which::value + 68: return ; case Which::value + 69: return ; case Which::value + 70: return ; case Which::value + 71: return ; case Which::value + 72: return ; case Which::value + 73: return ; case Which::value + 74: return ; case Which::value + 75: return ; case Which::value + 76: return ; case Which::value + 77: return ; case Which::value + 78: return ; case Which::value + 79: return ; case Which::value + 80: return ; case Which::value + 81: return ; case Which::value + 82: return ; case Which::value + 83: return ; case Which::value + 84: return ; case Which::value + 85: return ; case Which::value + 86: return ; case Which::value + 87: return ; case Which::value + 88: return ; case Which::value + 89: return ; case Which::value + 90: return ; case Which::value + 91: return ; case Which::value + 92: return ; case Which::value + 93: return ; case Which::value + 94: return ; case Which::value + 95: return ; case Which::value + 96: return ; case Which::value + 97: return ; case Which::value + 98: return ; case Which::value + 99: return ;
    }
}
};
    typedef void static_visitor_default_return;
}
template <typename R = ::boost::detail::static_visitor_default_return>
class static_visitor
{
public:
    typedef R result_type;
};
namespace detail {
union max_align
{
};
}
template<std::size_t Align>
class type_with_alignment
;
namespace detail { namespace aligned_storage {
template <
      std::size_t size_
    , std::size_t alignment_
>
struct aligned_storage_imp
{
    union data_t
    {
        typename ::boost::mpl::eval_if_c<
              alignment_ == std::size_t(-1)
            , ::boost::mpl::identity< ::boost::detail::max_align >
            , ::boost::type_with_alignment<alignment_>
            >::type align_;
    } data_;
    void* address() const { return const_cast<aligned_storage_imp*>(this); }
};
}}
template <
      std::size_t size_
    , std::size_t alignment_ = std::size_t(-1)
>
class aligned_storage :
   ::boost::detail::aligned_storage::aligned_storage_imp<size_, alignment_>
{
public:
    typedef ::boost::detail::aligned_storage::aligned_storage_imp<size_, alignment_> type;
    void* address()
    {
        return static_cast<type*>(this)->address();
    }
};
  using ::uintmax_t;
namespace math
{
     typedef boost::uintmax_t static_gcd_type;
namespace detail
{
    template < static_gcd_type Value1, static_gcd_type Value2 >
    struct static_lcm_helper_t
    ;
}
template < static_gcd_type Value1, static_gcd_type Value2 >
struct static_lcm : public mpl::integral_c<static_gcd_type, detail::static_lcm_helper_t<Value1, Value2>::value >
{
};
}}
namespace boost { namespace mpl { namespace aux {
template< bool C_, typename T1, typename T2, typename T3, typename T4 >
struct and_impl
    : and_impl<
          ::boost::mpl::aux::nested_type_wknd<T1>::value
        , T2, T3, T4
        , true_
        >
{
};
struct and_impl<
          true
        , true_, true_, true_, true_
        >
;
template<
      typename Iterator
    , typename State
    , typename ForwardOp
    , typename ForwardPredicate
    , typename BackwardOp
    , typename BackwardPredicate
    >
struct iter_fold_if_impl
;
template< typename Predicate, typename LastIterator >
struct iter_fold_if_pred
;
}
template<
      typename Sequence = na
    , typename State = na
    , typename ForwardOp = na
    , typename ForwardPredicate = na
    , typename BackwardOp = na
    >
struct iter_fold_if
{
    typedef typename begin<Sequence>::type first_;
    typedef typename end<Sequence>::type last_;
    typedef typename eval_if<
        >::type backward_pred_;
    struct result_ :
        aux::iter_fold_if_impl<
          first_
        , State
        , ForwardOp
        , protect< aux::iter_fold_if_pred< ForwardPredicate,last_ > >
        , BackwardOp
        , backward_pred_
        >
    { };
    typedef pair<
        > type;
};
template<
      typename Sequence = na
    , typename Predicate = na
    >
struct find_if
{
};
}}
namespace boost { namespace mpl { namespace aux {
template<
      int N
    , typename First
    , typename Last
    , typename State
    , typename ForwardOp
    >
struct fold_impl;
template<
      int N
    , typename First
    , typename Last
    , typename State
    , typename ForwardOp
    >
struct fold_impl
;
template<
      typename First
    , typename Last
    , typename State
    , typename ForwardOp
    >
struct fold_impl< -1,First,Last,State,ForwardOp >
;
}}}
namespace boost { namespace mpl {
template<
      typename Sequence = na
    >
struct is_sequence
;
namespace aux {
}
template<
      typename Sequence = na
    >
struct max_element
    : iter_fold<
          Sequence
        >
{
};
template<
      typename Sequence = na
    , typename T = na
    >
struct push_front
    : push_front_impl< typename sequence_tag<Sequence>::type >
        ::template apply< Sequence,T >
{
};
template<> struct push_front< na , na > { template< typename T1 , typename T2 , typename T3 =na , typename T4 =na , typename T5 =na > struct apply : push_front< T1 , T2 > { }; }; template< typename Tag > struct lambda< push_front< na , na > , Tag , int_<-1> > { typedef false_ is_le; typedef push_front< na , na > result_; typedef push_front< na , na > type; }; namespace aux { template< typename T1 , typename T2 > struct template_arity< push_front< T1 , T2 > > : int_<2> { }; template<> struct template_arity< push_front< na , na > > : int_<-1> { }; }
}}
namespace boost { namespace mpl { namespace aux {
template<
      long N
    , typename First
    , typename Last
    , typename State
    , typename BackwardOp
    , typename ForwardOp
    >
struct reverse_fold_impl;
template<
      typename First
    , typename Last
    , typename State
    , typename BackwardOp
    , typename ForwardOp
    >
struct reverse_fold_impl< 2,First,Last,State,BackwardOp,ForwardOp >
{
    typedef First iter0;
    typedef State fwd_state0;
    typedef typename apply2< ForwardOp, fwd_state0, typename deref<iter0>::type >::type fwd_state1;
    typedef typename mpl::next<iter0>::type iter1;
    typedef typename apply2< ForwardOp, fwd_state1, typename deref<iter1>::type >::type fwd_state2;
    typedef fwd_state2 bkwd_state2;
    typedef typename apply2< BackwardOp, bkwd_state2, typename deref<iter1>::type >::type bkwd_state1;
    typedef typename apply2< BackwardOp, bkwd_state1, typename deref<iter0>::type >::type bkwd_state0;
    typedef bkwd_state0 state;
};
template<
      typename First
    , typename Last
    , typename State
    , typename BackwardOp
    , typename ForwardOp
    >
struct reverse_fold_impl< 4,First,Last,State,BackwardOp,ForwardOp >
;
template<
      long N
    , typename First
    , typename Last
    , typename State
    , typename BackwardOp
    , typename ForwardOp
    >
struct reverse_fold_impl
;
template<
      typename First
    , typename Last
    , typename State
    , typename BackwardOp
    , typename ForwardOp
    >
struct reverse_fold_impl< -1,First,Last,State,BackwardOp,ForwardOp >
;
template<
      typename Last
    , typename State
    , typename BackwardOp
    , typename ForwardOp
    >
struct reverse_fold_impl< -1,Last,Last,State,BackwardOp,ForwardOp >
;
}}}
namespace boost { namespace mpl {
template<
      typename Sequence = na
    , typename State = na
    , typename BackwardOp = na
    , typename ForwardOp = arg<1>
    >
struct reverse_fold
{
    typedef typename aux::reverse_fold_impl<
          ::boost::mpl::O1_size<Sequence>::value
        , typename begin<Sequence>::type
        , typename end<Sequence>::type
        , State
        , BackwardOp
        , ForwardOp
        >::state type;
};
template<
      typename Sequence = na
    >
struct has_push_back
    : has_push_back_impl< typename sequence_tag<Sequence>::type >
        ::template apply< Sequence >
{
};
template<
      typename Sequence
    , typename Operation
    >
struct inserter
{
    typedef Sequence state;
    typedef Operation operation;
};
template<
      typename Sequence
    >
struct back_inserter
;
template<
      typename Sequence
    >
struct front_inserter
    : inserter< Sequence,push_front<> >
{
};
template<
      typename Sequence = na
    >
struct clear
    : clear_impl< typename sequence_tag<Sequence>::type >
        ::template apply< Sequence >
{
};
namespace aux {
template<
      typename Seq
    , typename Op
    , typename In
    >
struct transform1_impl
;
template<
      typename Seq
    , typename Op
    , typename In
    >
struct reverse_transform1_impl
    : reverse_fold<
          Seq
        , typename In::state
        , bind2< typename lambda< typename In::operation >::type
            , _1
            , bind1< typename lambda<Op>::type, _2>
            >
        >
{
};
template<
      typename Seq1
    , typename Seq2
    , typename Op
    , typename In
    >
struct transform2_impl
;
template<
      typename Seq1
    , typename Seq2
    , typename Op
    , typename In
    >
struct reverse_transform2_impl
;
}
 template< typename P1 = na , typename P2 = na , typename P3 = na > struct transform1 : aux::transform1_impl< P1 , P2 , P3> { }; template< typename P1 , typename P2 > struct transform1< P1 , P2,na > : if_< has_push_back< typename clear<P1>::type> , aux::transform1_impl< P1 , P2 , back_inserter< typename clear<P1>::type > > , aux::reverse_transform1_impl< P1 , P2 , front_inserter< typename clear<P1>::type > > >::type { }; template< typename P1 = na , typename P2 = na , typename P3 = na > struct reverse_transform1 : aux::reverse_transform1_impl< P1 , P2 , P3> { }; template< typename P1 , typename P2 > struct reverse_transform1< P1 , P2,na > : if_< has_push_back<P1> , aux::reverse_transform1_impl< P1 , P2 , back_inserter< typename clear<P1>::type > > , aux::transform1_impl< P1 , P2 , front_inserter< typename clear<P1>::type > > >::type { }; template<> struct transform1< na , na , na > ; template< typename Tag > struct lambda< transform1< na , na , na > , Tag , int_<-1> > ; namespace aux { template< typename T1 , typename T2 , typename T3 > struct template_arity< transform1< T1 , T2 , T3 > > : int_<3> { }; template<> struct template_arity< transform1< na , na , na > > : int_<-1> { }; } template<> struct reverse_transform1< na , na , na > ; template< typename Tag > struct lambda< reverse_transform1< na , na , na > , Tag , int_<-1> > ; namespace aux { template< typename T1 , typename T2 , typename T3 > struct template_arity< reverse_transform1< T1 , T2 , T3 > > : int_<3> { }; template<> struct template_arity< reverse_transform1< na , na , na > > : int_<-1> { }; }
 template< typename P1 = na , typename P2 = na , typename P3 = na , typename P4 = na > struct transform2 : aux::transform2_impl< P1 , P2 , P3 , P4> { }; template< typename P1 , typename P2 , typename P3 > struct transform2< P1 , P2 , P3,na > : if_< has_push_back< typename clear<P1>::type> , aux::transform2_impl< P1 , P2 , P3 , back_inserter< typename clear<P1>::type > > , aux::reverse_transform2_impl< P1 , P2 , P3 , front_inserter< typename clear<P1>::type > > >::type { }; template< typename P1 = na , typename P2 = na , typename P3 = na , typename P4 = na > struct reverse_transform2 : aux::reverse_transform2_impl< P1 , P2 , P3 , P4> { }; template< typename P1 , typename P2 , typename P3 > struct reverse_transform2< P1 , P2 , P3,na > : if_< has_push_back<P1> , aux::reverse_transform2_impl< P1 , P2 , P3 , back_inserter< typename clear<P1>::type > > , aux::transform2_impl< P1 , P2 , P3 , front_inserter< typename clear<P1>::type > > >::type { }; template<> struct transform2< na , na , na , na > ; template< typename Tag > struct lambda< transform2< na , na , na , na > , Tag , int_<-1> > ; namespace aux { template< typename T1 , typename T2 , typename T3 , typename T4 > struct template_arity< transform2< T1 , T2 , T3 , T4 > > : int_<4> { }; template<> struct template_arity< transform2< na , na , na , na > > : int_<-1> { }; } template<> struct reverse_transform2< na , na , na , na > ; template< typename Tag > struct lambda< reverse_transform2< na , na , na , na > , Tag , int_<-1> > ; namespace aux { template< typename T1 , typename T2 , typename T3 , typename T4 > struct template_arity< reverse_transform2< T1 , T2 , T3 , T4 > > : int_<4> { }; template<> struct template_arity< reverse_transform2< na , na , na , na > > : int_<-1> { }; }
template< typename Seq1 = na , typename Seq2OrOperation = na , typename OperationOrInserter = na , typename Inserter = na > struct transform { typedef typename eval_if< or_< is_na<OperationOrInserter> , is_lambda_expression< Seq2OrOperation > , not_< is_sequence<Seq2OrOperation> > > , transform1<Seq1,Seq2OrOperation,OperationOrInserter> , transform2<Seq1,Seq2OrOperation,OperationOrInserter,Inserter> >::type type; }; template<> struct transform< na , na , na , na > ; template< typename Tag > struct lambda< transform< na , na , na , na > , Tag , int_<-1> > ; namespace aux { template< typename T1 , typename T2 , typename T3 , typename T4 > struct template_arity< transform< T1 , T2 , T3 , T4 > > : int_<4> { }; template<> struct template_arity< transform< na , na , na , na > > : int_<-1> { }; }
}}
namespace boost {
namespace detail { namespace variant {
template <class Types>
struct is_variant_move_noexcept_constructible {
    typedef typename boost::mpl::find_if<
        Types, mpl::not_<boost::is_nothrow_move_constructible<boost::mpl::_1> >
    >::type iterator_t;
};
template <typename Types, typename NeverUsesBackupFlag>
struct make_storage
{
    typedef typename mpl::eval_if<
        >::type max_size;
    typedef ::boost::aligned_storage<
          max_size::value
        > type;
};
class move_into
    : public static_visitor<>
{
    void* storage_;
public:
    explicit move_into(void* storage) noexcept
    ;
    template <typename T>
        void
    internal_visit(boost::detail::variant::backup_holder<T>& operand, long) const
    {
        new(storage_) T( ::boost::detail::variant::move(operand.get()) );
    }
};
}}
template <
      typename T0_
    , typename... TN
    >
class variant
{
    struct is_recursive_
        : detail::variant::is_recursive_flag<T0_>
    {
    };
    typedef typename mpl::eval_if<
          is_recursive_
        , T0_
        , mpl::identity< T0_ >
        >::type unwrapped_T0_;
    struct is_sequence_based_
        : detail::variant::is_over_sequence<unwrapped_T0_>
    {
    };
    typedef typename mpl::eval_if<
          is_sequence_based_
        , unwrapped_T0_
        , detail::variant::make_variant_list<
              unwrapped_T0_
            , TN...
            >
        >::type recursive_enabled_types;
    typedef typename mpl::transform<
          recursive_enabled_types
        , unwrap_recursive<mpl::_1>
        >::type types;
    typedef typename mpl::transform<
          recursive_enabled_types
        , mpl::protect< detail::make_reference_content<> >
        >::type internal_types;
    struct has_fallback_type_
        : mpl::not_<
            >
    {
    };
    typedef has_fallback_type_
        never_uses_backup_flag;
    typedef typename detail::variant::make_storage<
          internal_types, never_uses_backup_flag
        >::type storage_t;
    typedef typename detail::variant::is_variant_move_noexcept_constructible<
        internal_types
    > variant_move_noexcept_constructible;
    typedef int which_t;
    which_t which_;
    storage_t storage_;
    void indicate_which(int which_arg) noexcept
    {
    }
    int which() const noexcept
    {
    }
    struct initializer
        : ::boost::mpl::iter_fold< recursive_enabled_types , ::boost::mpl::pair< ::boost::detail::variant::initializer_root , ::boost::mpl::int_<0> > , ::boost::mpl::protect< ::boost::detail::variant::make_initializer_node > >::type::first
    {
    };
    template <typename T>
    void convert_construct(
          T& operand
        , int
        )
    {
        indicate_which(
              initializer::initialize(
                  storage_.address()
                , operand
                )
            );
    }
public:
    template <typename T>
    variant(const T& operand)
    {
        convert_construct(operand, 1L);
    }
    variant(variant&& operand) noexcept
    {
        detail::variant::move_into visitor( storage_.address() );
        operand.internal_apply_visitor(visitor);
    };
    template <typename Visitor, typename VoidPtrCV>
        typename Visitor::result_type
    internal_apply_visitor_impl(
          int internal_which
        , int logical_which
        , Visitor& visitor
        , VoidPtrCV storage
        )
    {
        typedef mpl::int_<0> first_which;
        typedef typename mpl::begin<internal_types>::type first_it;
        typedef typename mpl::end<internal_types>::type last_it;
        typedef detail::variant::visitation_impl_step<
              first_it, last_it
            > first_step;
        return detail::variant::visitation_impl(
              internal_which, logical_which
            , visitor, storage, mpl::false_()
            , never_uses_backup_flag()
            , static_cast<first_which*>(0), static_cast<first_step*>(0)
            );
    }
    template <typename Visitor>
        typename Visitor::result_type
    internal_apply_visitor(Visitor& visitor)
    {
        return internal_apply_visitor_impl(
              which_, which(), visitor, storage_.address()
            );
    }
    template <typename Visitor>
    internal_apply_visitor(Visitor& visitor) const
    {
    }
};
}
namespace padis {
namespace listener {
namespace tlv {
inline namespace _v1 {
namespace traits {
template<typename TlvConfig, class UnsupportedTlvClass, class... TlvClasses>
struct generic_element_tlvs;
template<typename TlvConfig, class UnsupportedTlvClass, class TlvF, class... TlvR>
struct generic_element_tlvs<TlvConfig, UnsupportedTlvClass, TlvF, TlvR...> {
    typedef typename std::conditional<std::is_void<UnsupportedTlvClass>::value,
            boost::variant<TlvF, TlvR...>,
            boost::variant<UnsupportedTlvClass, TlvF, TlvR...>
        >::type variant_type;
};
}
template<typename TlvConfig, typename ElementTlvs>
class GenericTlvContainer {
public:
    typedef typename ElementTlvs::variant_type tlv_type;
    template<class TlvClass>
    inline void addTlv(const TlvClass &tlv);
    std::vector<tlv_type> tlvs_;
};
template<typename TlvConfig, typename ElementTlvs>
template<class TlvClass>
inline void GenericTlvContainer<TlvConfig, ElementTlvs>::addTlv(const TlvClass &tlv) {
    tlv_type wrap(tlv);
    tlvs_.push_back(std::move(wrap));
}
}
inline namespace _v1 {
template<typename TlvConfig, typename TlvConfig::code_type Id, class ImplClass, std::size_t MinLen, std::size_t MaxLen=MinLen>
class GenericFixedLengthTlvBase : public virtual GenericTlvBase<TlvConfig, Id, ImplClass> {
    virtual inline std::size_t getValueLength() const override;
};
template <typename TlvConfig>
class GenericUnsupportedTlv
    : public virtual GenericTlv<TlvConfig>
{
    virtual std::size_t getHeaderLength() const override;
    virtual std::size_t getMaximumValueLength() const override;
    virtual std::size_t getMinimumValueLength() const override;
    virtual std::size_t getValueLength() const override;
    virtual typename TlvConfig::code_type getCode() const override;
    virtual bool operator==(const GenericTlv<TlvConfig>& other) const override;
    std::size_t length_;
};
}
}
}
namespace isislistener {
namespace tlv {
namespace traits {
    using isis_tlv_config= listener::tlv::traits::generic_tlv_config<std::uint8_t, 2, 1, 255>;
    template<class... TlvClasses>
    using isis_element_tlvs= listener::tlv::traits::generic_element_tlvs<isis_tlv_config, listener::tlv::GenericUnsupportedTlv<isis_tlv_config>, TlvClasses...>;
}
template<std::uint8_t Id, class ImplClass, std::size_t MinLen, std::size_t MaxLen=MinLen>
using FixedLengthTlvBase= listener::tlv::GenericFixedLengthTlvBase<traits::isis_tlv_config, Id, ImplClass, MinLen, MaxLen>;
}
namespace tlv {
namespace te {
class IPv4NeighborAddressSubTlv : public FixedLengthTlvBase<8, IPv4NeighborAddressSubTlv, 4> {
    bool operator==(const IPv4NeighborAddressSubTlv &other) const override;
};
}
typedef tlv::traits::isis_element_tlvs<
    te::IPv4NeighborAddressSubTlv
    >
extended_is_reachability_sub_tlvs;
class ExtendedIsReachabilityEntry : public listener::tlv::GenericTlvContainer<traits::isis_tlv_config, extended_is_reachability_sub_tlvs> {
};
}
}
}
namespace padis
{
namespace isislistener
{
void test()
{
    tlv::ExtendedIsReachabilityEntry isEntry;
    tlv::te::IPv4NeighborAddressSubTlv nbAddressSubTlv;
    isEntry.addTlv(nbAddressSubTlv);
}
}
}
 